routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['prefix' => '', 'namespace' => 'Shop', 'as' => 'shop.'], function () {
    Route::get('/', 'ShopController@index')->name('index');
    // Route::get('/the-loai/{slugParent}/{slug}', 'ShopController@categoryList')->name('categorylist');
    Route::get('/san-pham/chi-tiet/{id}', 'ShopController@show')->name('detail');
    Route::get('/all-products', 'ShopController@allProducts')->name('allproducts');
    Route::get('/all-articles', 'ShopController@allArticles')->name('allarticles');
    Route::get('/bai-viet/{id}', 'ShopController@detailArticle')->name('detailarticle');
    // Route::get('/category-list/{name}_{id}', 'ShopController@categoryList')->name('categorylist');
    Route::group(['prefix' => 'Cart', 'as' => 'cart.', 'middleware' => ['auth']], function () {
        Route::post('/add-product-cart', 'ShopController@addProductToCart')->name('addproducttocart');
        Route::get('/gio-hang-cua-ban', 'ShopController@listCartProduct')->name('listcart');
        Route::post('/remove-item-cart', 'ShopController@removeItemCart')->name('removeitemcart');
        Route::post('/add-cart', 'ShopController@addCart')->name('addcart');
        Route::get('/ajax-show-cart', 'ShopController@ajaxShowCart')->name('ajaxshowcart');
        Route::get('/lich-su-giao-dich', 'ShopController@historyOrder')->name('historyorder');
    });
    Route::group(['prefix' => 'Info', 'as' => 'info.', 'middleware' => ['auth']], function () {
        Route::get('/thong-tin-tk', 'ShopController@showInfo')->name('showinfo');
        Route::post('/change/thong-tin-tk', 'ShopController@changeInfo')->name('changeinfo');
    });
    // Route::post('/comment/add/{slug}_{id}', 'ShopController@addComment')->name('addcomment');
    // Route::get('/about-us', 'ShopController@aboutUs')->name('about');
    // Route::get('/contact-us', 'ShopController@contactUs')->name('contact');
    // Route::post('/contact-us/add', 'ShopController@addContact')->name('addcontact');
});
Route::get('/login-admin', 'Admin\AdminController@loginAdmin')->name('loginadmin');
Route::group(['prefix' => 'admin', 'namespace' => 'Admin', 'as' => 'admin.', 'middleware' => ['checktype']], function () {
    Route::get('/', 'AdminController@index')->name('index');
    Route::group(['prefix' => 'categoryproduct', 'as' => 'categoryproduct.'], function () {
        Route::get('/', 'CategoryProductController@index')->name('list');
        Route::get('/add', 'CategoryProductController@create')->name('add');
        Route::post('/created', 'CategoryProductController@store')->name('created');
        Route::get('edit/{id}', 'CategoryProductController@edit')->name('edit');
        Route::post('/{id}', 'CategoryProductController@update')->name('update');
        Route::delete('/deletecate', 'CategoryProductController@destroy')->name('destroy');
    });
    Route::group(['prefix' => 'product', 'as' => 'product.'], function () {
        Route::get('/', 'ProductController@index')->name('list');
        Route::get('/add', 'ProductController@create')->name('add');
        Route::post('/created', 'ProductController@store')->name('created');
        Route::get('edit/{id}', 'ProductController@edit')->name('edit');
        Route::post('/{id}', 'ProductController@update')->name('update');
        Route::delete('/product/{id}', 'ProductController@destroy')->name('destroy');
        Route::post('/deleteimage', 'ProductController@deleteImage')->name('deleteimage');
        Route::post('/uploadimage/{type?}', 'ProductController@UploadMultiple')->name('uploadimage');
    });

    Route::group(['prefix' => 'categoryarticle', 'as' => 'categoryarticle.'], function () {
        Route::get('/', 'CategoryArticleController@index')->name('list');
        Route::get('/add', 'CategoryArticleController@create')->name('add');
        Route::post('/created', 'CategoryArticleController@store')->name('created');
        Route::get('edit/{id}', 'CategoryArticleController@edit')->name('edit');
        Route::post('/{id}', 'CategoryArticleController@update')->name('update');
        Route::delete('/deletecate', 'CategoryArticleController@destroy')->name('destroy');
    });
    Route::group(['prefix' => 'article', 'as' => 'article.'], function () {
        Route::get('/', 'ArticleController@index')->name('list');
        Route::get('/add', 'ArticleController@create')->name('add');
        Route::post('/created', 'ArticleController@store')->name('created');
        Route::get('edit/{id}', 'ArticleController@edit')->name('edit');
        Route::post('/{id}', 'ArticleController@update')->name('update');
        Route::delete('/article/{id}', 'ArticleController@destroy')->name('destroy');
        Route::post('/deleteimage', 'ArticleController@deleteImage')->name('deleteimage');
        Route::post('/uploadimage/{type?}', 'ArticleController@UploadMultiple')->name('uploadimage');
    });
     Route::group(['prefix' => 'order', 'as' => 'order.'], function () {
        Route::get('/', 'OrderController@index')->name('list');
        Route::get('/add', 'OrderController@create')->name('add');
        Route::post('/searchproductname', 'OrderController@searchProductName')->name('searchproductname');
        Route::post('/created', 'OrderController@store')->name('created');
        Route::get('edit/{id}', 'OrderController@edit')->name('edit');
        Route::post('/{id}', 'OrderController@update')->name('update');
        Route::delete('/deletecate', 'OrderController@destroy')->name('destroy');
    });
});
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Http/Controllers/Shop/ShopController.php
<?php

namespace App\Http\Controllers\Shop;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\CategoryProduct;
use App\Models\CategoryArticle;
use App\Models\Product;
use App\Models\Article;
use App\Models\Order;
use App\User;
use App\Models\OrderDetail;
use Cart;
use Carbon\Carbon;
use Response;
use View;
use Auth;
use Hash;
use App\Http\Requests\UserRequest;

class ShopController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $categories = CategoryProduct::where('status', 1)->get();
        $products = Product::where('status', 1)->get();
        return view('shop.index', ['categories' => $categories, 'products' => $products]);
    }

    public function allProducts()
    {
        $products = Product::select()->where('status', 1)->paginate(5);
        return view('shop.all_products.all_products', ['products' => $products]);
    }

    public function allArticles()
    {
        $articles = Article::select()->where('status', 1)->paginate(5);
        return view('shop.all_articles.all_articles', ['articles' => $articles]);
    }

    public function detailArticle($id)
    {
        $article = Article::findOrFail($id);
        $categories = CategoryArticle::all();
        return view('shop.all_articles.detail_article', ['article' => $article, 'categories' => $categories]);
    }

    public function addProductToCart(Request $request)
    {
        $product = Product::find($request->id);
        if ($product) {
            Cart::add(
                ['id' => $request->id,
                    'name' => $product->name,
                    'qty' => $request->quantity_input,
                    'price' => $product->price,
                    'weight' => 550,
                    'options' => ['image' => $product->images->first()->src ?? 'error'
                    ]]);
        }
        return redirect()->back();
    }

    public function ajaxShowCart()
    {
        $products = Cart::Content();
        $total = Cart::total();
        return Response::json(View::make('shop.cart.show-ajax-cart', array('items' => $products, 'total' => $total))->render());
    }

    public function listCartProduct()
    {
        $products = Cart::content();
        $viewData = [
            'products' => $products
        ];
        return view('shop.cart.show-cart', ['products' => $products]);
    }

    public function removeItemCart(Request $request)
    {
        Cart::remove($request->rowId);
        $status = 'true';
        $totalNew = Cart::total();
        $msg[] = ['status' => $status,
            'totalNew' => $totalNew];
        return $msg;
    }

    public function addCart(Request $request)
    {
        $products = Cart::Content();
        if (count($products) == 0) {
            return redirect()->back()->with('status', 'Chưa có sản phẩm trong giỏ hàng');
        }
        if ($request->use_user == "on") {
            $orderAdd['name'] = auth()->user()->name;
            $orderAdd['phone'] = auth()->user()->phone;
            $orderAdd['delivery_address'] = auth()->user()->address;
        } else {
            $orderAdd = $request->all();
        }
        $orderAdd['order_date'] = Carbon::now()->toDateTimeString();
        $orderAdd['user_id'] = auth()->user()->id;
        $total = Cart::total();
        $result = str_replace(",", "", $total);
        $orderAdd['total'] = (int)$result;
        $orderAdd['status'] = 1;
        $order = Order::create($orderAdd);
        foreach ($products as $product) {
            $order->orderDetails()->create(['product_id' => $product->id, 'order_id' => $order->id, 'quantity' => $product->qty, 'until_price' => $product->price]);
        }
        Cart::destroy();
        return redirect()->route('shop.index')->with('status', 'Đơn Hàng của bạn đã được lưu!');
    }

    public function historyOrder()
    {
        $usersOrder = Order::where('user_id', auth()->user()->id)->get();
        return view('shop.cart.history-order', ['usersOrder' => $usersOrder]);
    }


    public function show($id)
    {
        $product = Product::findOrFail($id);
        return view('shop.detail.detail', ['product' => $product]);
    }

    public function showInfo()
    {
        $user = auth()->user();
        return view('shop.info-user.info-user', ['user' => $user]);
    }

    public function changeInfo(UserRequest $request)
    {
        $user = User::findOrFail($request->id);
        $request_data = $request->all();
        if (!is_null($request_data['password_confirmation']) && !is_null($request_data['password_confirmation'])) {
            $current_password = Auth::User()->password;
            if (Hash::check($request_data['old_password'], $current_password)) {
                $user->password = Hash::make($request_data['password']);;
                $request_data = ['password', $user->password];
            } else {
                return redirect()->back()->with('error', 'Mật khẩu cũ không đúng');
            }
        }
        $user->update($request_data);
        return redirect()->back()->with('message', 'Cập nhật thông tin tài khoản thành công !!');
    }
}

resources/views/shop/cart/history-order.blade.php
@extends('shop.cart.layouts_cart',['nameMenu'=>'Lịch sử giao dịch'])
@section('content-cart')
    @if(!$usersOrder->first())
        <div class="alert alert-danger col-md-12 row" role="alert">
            Chưa phát sinh đơn hàng nào !
        </div>
    @else
    <div class="container">
        <div class="col-md-12 row">
            <p>Thông tin các đơn hàng của bạn đã được hệ thống lưu lại</p>
        </div>

        <table class="table table-hover">
            <thead>
            <tr>
                <th>Mã đơn hàng</th>
                <th>Ngày đặt hàng</th>
                <th>Tổng tiền</th>
                <th>Trạng thái đơn hàng</th>
            </tr>
            </thead>
            <tbody>
            @foreach($usersOrder as $order)
                <tr>
                    <td>{{$order->id}}</td>
                    <td>{{date('d-m-Y', strtotime($order->order_date))}}</td>
                    <td>{{ number_format($order->total,0,',','.') }}</td>
                    @if($order->status == 2)
                        <td>Đơn hàng đã được giao thành công</td>
                    @elseif($order->status == 3)
                        <td>Đơn hàng đã được hủy</td>
                    @else
                        <td>Đang xử lý đơn hàng</td>
                    @endif
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
    @endif
@endsection

resources/views/shop/cart/layouts_cart.blade.php
@extends('shop.layouts.master')
@section('styles')
    <style type="text/css">
    
    </style>
    @yield('styles-layouts-cart')
@endsection
@section('content')
	<section class="container cart_container">
        <div class="row">
        	 <div class="col-md-4">
                @include('shop.cart.menu-cart')
            </div>
             <div class="col-md-8">
                <div class="col-md-12 cart_title">
                   @if($nameMenu)
                   {{$nameMenu}}
                   @else
                        Thông Tin
                    @endif
            	</div>
            	@yield('content-cart')
            </div>	
        </div>
    </section>
@endsection

resources/views/shop/cart/menu-cart.blade.php
<div class=" sidebar menu-info-container">
    <div class="mini-submenu">
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
    </div>
    <div class="list-group">
        <span href="#" class="list-group-item list-group-item-parent">
          Xin Chào {{(Auth::user()->name)}}
            <span class="pull-right" id="slide-submenu">
                <i class="fa fa-times"></i>
            </span>
        </span>
<!--         <a href="#" class="list-group-item">
            <i class="fa fa-comment-o"></i> Lorem ipsum
        </a> -->
        <a href="{{route('shop.cart.historyorder')}}" class="list-group-item">
            <i class="fa fa-search"></i> Lịch sử giao dịch
        </a>
        <a href="{{route('shop.info.showinfo')}}" class="list-group-item">
            <i class="fa fa-user"></i> Thông tin tài khoản
        </a>
        <a href="{{route('shop.cart.listcart')}}" class="list-group-item">
            <i class="fa fa-bar-chart-o"></i> Thông tin đơn hàng<span class="badge">{{Cart::count()}}</span>
        </a>
    </div>        
</div>

resources/views/shop/cart/show-ajax-cart.blade.php
@if(!$items->first())
    <div class="alert alert-danger" role="alert">
        Giỏ hàng chưa có sản phẩm
    </div>
@else
    @foreach($items as $item)
        <div class="row">
            <div class="col-lg-3">
                <img src="{{$item->options->image ?? 'error'}} " class="img-thumbnail">
            </div>
            <div class="col-lg-3">
                <p class="text-center"> Tên SP </p>
                <p class="text-center"> {{$item->name}} </p>
            </div>
            <div class="col-lg-3">
                <p class="text-center"> Số Lượng </p>
                <p class="text-center"> {{$item->qty}} </p>
            </div>
            <div class="col-lg-3">
                <p class="text-center"> Tổng tiền </p>
                <p class="text-center"> {{number_format($item->price * $item->qty,0,',','.')}} </p>
            </div>
        </div>
    @endforeach
    <div class="row">
        <div class="col-lg-12">
            <p class="text-right"> Tổng tiền giỏ hàng </p>
            <p class="text-right">  {{$total}}  </p>
        </div>
    </div>
@endif

resources/views/shop/cart/show-cart.blade.php
@extends('shop.cart.layouts_cart',['nameMenu'=>'Thông tin đơn hàng'])
@section('content-cart')
    @if(!$products->first())
        <div class="col-md-12 cart_content_list">
            <div class="alert alert-danger text-center" role="alert">
                Giỏ hàng chưa có sản phẩm !
            </div>
        </div>
    @else
        <div class="col-md-12 cart_content_list">
            @foreach($products as $product)
                <div class="row cart_item">
                    <div class="col-lg-2 col-md-12">
                        <div class="cart_item_image">
                            <img src="{{$product->options->image ??  '/shop/assets/images/product/single.jpg'}}"
                                 alt="">
                        </div>
                    </div>
                    <div class="col-lg-2 col-md-12">
                        <div class="cart_item_name cart_info_col">
                            <div class="cart_item_title">Name</div>
                            <div class="cart_item_text">{{$product->name}}</div>
                        </div>
                    </div>
                    <div class="col-lg-2 col-md-12">
                        <div class="cart_item_quantity cart_info_col">
                            <div class="cart_item_title">Quantity</div>
                            <div class="cart_item_text">{{ $product->qty }}</div>
                        </div>
                    </div>
                    <div class="col-lg-2 col-md-12">
                        <div class="cart_item_price cart_info_col">
                            <div class="cart_item_title">Price</div>
                            <div class="cart_item_text">{{ number_format($product->price,0,',','.') }}</div>
                        </div>
                    </div>
                    <div class="col-lg-2 col-md-12">
                        <div class="cart_item_total cart_info_col">
                            <div class="cart_item_title">Total</div>
                            <div class="cart_item_text">{{ number_format($product->total,0,',','.') }}</div>
                        </div>
                    </div>
                    <div class="col-lg-2 col-md-12">
                        <div class="cart_item_total cart_info_col">
                            <div class="cart_item_title">Xóa</div>
                            <div class="cart_item_text">
                                <button type="button" class="btn btn-danger btnRemoveItem"
                                        onclick="removeItemCart('{{$product->rowId}}',this)"
                                        data-id="{{$product->rowId}}">
                                    Xóa
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            @endforeach
        </div>
    @endif
    <div class="col-md-12">
        <div class="order_total">
            <div class="order_total_content text-md-right">
                <div class="order_total_title">Tổng Tiền Giỏ Hàng :</div>
                <div class="order_total_amount">{{Cart::total()}} VNĐ</div>
            </div>
        </div>
    </div>
    <div class="col-md-12 cart_title">
        Thông Tin Khách Hàng
    </div>
    <div class="col-md-12">
        <form action="{{route('shop.cart.addcart')}}" method="post" id="contact_form">
            @csrf
            <div class="contact_form_inputs d-flex flex-md-row flex-column justify-content-between align-items-between">
                <input type="text" id="shipment_address" name="shipment_address"
                       class="contact_form_email input_field" placeholder="Địa chỉ giao hàng" required
                       autocomplete="shipment_address">
                <input type="text" id="shipment_name" name="shipment_name"
                       class="contact_form_email input_field" required placeholder="Tên người nhận"
                       required="required" data-error="shipment_name is required.">
                <input type="text" id="phone" name="phone"
                       class="contact_form_email input_field" required placeholder="Số điện thoại"
                       required="required" data-error="phone is required.">
            </div>
            <div class="contact_form_button">
                <button type="submit" class="btn btn-info" {{!$products->first() ? 'disabled' : ''}}>Thanh Toán</button>
            </div>
        </form>
    </div>
@endsection